
precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;


uniform vec3 blendColor;

void main()
{
    vec4 texColor;
    if(CC_TextureAlpha == 0.0) {
        texColor = texture2D(CC_Texture0, v_texCoord);
    } else {
        texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        texColor.rgb *= texColor.a; // premultiply alpha channel
    }

    texColor.r += blendColor.x*texColor.a;
    texColor.g += blendColor.y*texColor.a;
    texColor.b += blendColor.z*texColor.a;
    gl_FragColor = texColor * v_fragmentColor;
}
