precision mediump float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture1;
uniform float u_splitUV;
uniform float u_yPixelOffset;
void main()
{
    vec4 texColor;
    vec4 colorMaping;
    float x, y;
    if(CC_TextureAlpha == 0.0) {
        texColor = texture2D(CC_Texture0, v_texCoord);
        texColor.rgb /= texColor.a;
    } else {
        texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
    }
    y = texColor.r;
    x = texColor.b;
    float bar_group = floor((texColor.g * 255.0 - 30.0) / 60.0);
    float t_start = bar_group * u_splitUV;

    y = t_start + ceil((y * 255.0 - 15.0) / 30.0)/8.0*u_splitUV - u_yPixelOffset * 5.0;
    vec2 newUV = vec2(x + 0.05, y);
    colorMaping =  texture2D(u_texture1, newUV);
    colorMaping.a = texColor.a;
    colorMaping.rgb *= colorMaping.a;
    gl_FragColor = colorMaping * v_fragmentColor;
}