precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;



uniform float time;
uniform float negate;
uniform sampler2D u_texture1;


void main()
{
    vec4 texColor;
    if(CC_TextureAlpha == 0.0) {
        texColor = texture2D(CC_Texture0, v_texCoord);
    } else {
        texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        texColor.rgb *= texColor.a; // premultiply alpha channel
    }

    // 纹理坐标
    vec2 uv = v_texCoord;
    // 法向纹理r通道
    float height = texture2D(u_texture1,uv).r;

    //采样纹理
    vec4 color = v_fragmentColor * texColor;

    if(negate > 0.0){
       if(height > time)
        {
             discard;
        }

        if(height > time - 0.06)
          {
                     // 高亮
                     color = vec4(1.0,1.0,0.84,color.a);
           }

         if(height > time - 0.038)
         {
             // 过度
             color = vec4(0.98,0.64,0.35,color.a);
          }
           if(height > time - 0.015)
            {
                 // 暗部
                  color = vec4(0.49,0.32,0.2,color.a);
          }
    }else{
        if(height < time)
        {
            discard;
        }

        if(height < time + 0.04)
        {
            // 溶解颜色，可以自定义
            color = vec4(0.9,0.6,0.3,color.a);
        }
    }


    gl_FragColor = color;
}
