
precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec3 CC_defaultColor;
uniform vec2 CC_textureSize;
uniform float horizontal;
uniform float BlurSize;

void main()
{
    float weight[5];
    weight[0] = 0.227027;
    weight[1] = 0.1945946;
    weight[2] = 0.1216216;
    weight[3] = 0.054054;
    weight[4] = 0.016216;

    vec2 tex_offset = 1.0 / CC_textureSize * BlurSize;
    vec4 result = texture2D(CC_Texture0, v_texCoord) * weight[0];
    float wgt;
    if(horizontal == 0.0) {
        for(float i = 1.0; i < 5.0; i += 1.0)
        {
            if(i == 1.0) wgt = weight[1];
            else if(i == 2.0) wgt = weight[2];
            else if(i == 3.0) wgt = weight[3];
            else if(i == 4.0) wgt = weight[4];

            result += texture2D(CC_Texture0, v_texCoord + vec2(tex_offset.x * i, 0.0)) * wgt;
            result += texture2D(CC_Texture0, v_texCoord - vec2(tex_offset.x * i, 0.0)) * wgt;
        }
    }
    else {
        for(float i = 1.0; i < 5.0; i += 1.0)
        {
            if(i == 1.0) wgt = weight[1];
            else if(i == 2.0) wgt = weight[2];
            else if(i == 3.0) wgt = weight[3];
            else if(i == 4.0) wgt = weight[4];

            result += texture2D(CC_Texture0, v_texCoord + vec2(0.0, tex_offset.y * i)) * wgt;
            result += texture2D(CC_Texture0, v_texCoord - vec2(0.0, tex_offset.y * i)) * wgt;
        }
    }

    gl_FragColor = v_fragmentColor * result;
}
