
precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec4 CC_defaultColor;
uniform vec2 CC_textureSize;

void main()
{
    vec2 tex_offset = 1.0 / CC_textureSize;

    vec4 sum = vec4(0.0);
    if(CC_TextureAlpha == 0.0) {
        sum += texture2D(CC_Texture0, v_texCoord) * 4.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(tex_offset.x, 0.0)) * 2.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(-tex_offset.x, 0.0)) * 2.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(0.0, tex_offset.y)) * 2.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(0.0, -tex_offset.y)) * 2.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(-tex_offset.x, -tex_offset.y)) * 1.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(tex_offset.x, -tex_offset.y)) * 1.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(-tex_offset.x, tex_offset.y)) * 1.0;
        sum += texture2D(CC_Texture0, v_texCoord + vec2(tex_offset.x, tex_offset.y)) * 1.0;
    } else {
        sum += vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r) * 4.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(tex_offset.x, 0.0)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(tex_offset.x, 0.0)).r) * 2.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(-tex_offset.x, 0.0)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(-tex_offset.x, 0.0)).r) * 2.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(0.0, tex_offset.y)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(0.0, tex_offset.y)).r) * 2.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(0.0, -tex_offset.y)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(0.0, -tex_offset.y)).r) * 2.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(-tex_offset.x, -tex_offset.y)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(-tex_offset.x, -tex_offset.y)).r) * 1.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(tex_offset.x, -tex_offset.y)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(tex_offset.x, -tex_offset.y)).r) * 1.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(-tex_offset.x, tex_offset.y)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(-tex_offset.x, tex_offset.y)).r) * 1.0;
        sum += vec4(texture2D(CC_Texture0, v_texCoord + vec2(tex_offset.x, tex_offset.y)).rgb, texture2D(CC_Texture1, v_texCoord + vec2(tex_offset.x, tex_offset.y)).r) * 1.0;
    }
    sum /= 16.0;

    if(sum.a > 0.1) sum = CC_defaultColor;

    gl_FragColor = sum;
}
