precision mediump float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float glowSize;
uniform float withImage;
uniform vec2 texSize;
uniform vec3 glowColor;

void main()
{
    vec2 tex_offset = 1.0 / texSize * glowSize;
    vec4 result;
    float alpha = 0.0; // 4.0 * result.a;

    if(CC_TextureAlpha == 0.0) {
        result = texture2D(CC_Texture0, v_texCoord);
        alpha = 4.0 * result.a;
        alpha -= texture2D( CC_Texture0, v_texCoord + vec2( tex_offset.x, 0.0 ) ).a;
        alpha -= texture2D( CC_Texture0, v_texCoord + vec2( -tex_offset.x, 0.0 ) ).a;
        alpha -= texture2D( CC_Texture0, v_texCoord + vec2( 0.0, tex_offset.y ) ).a;
        alpha -= texture2D( CC_Texture0, v_texCoord + vec2( 0.0, -tex_offset.y) ).a;
    } else {
        result = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        alpha = 4.0 * result.a;
        alpha -= texture2D( CC_Texture1, v_texCoord + vec2( tex_offset.x, 0.0 ) ).r;
        alpha -= texture2D( CC_Texture1, v_texCoord + vec2( -tex_offset.x, 0.0 ) ).r;
        alpha -= texture2D( CC_Texture1, v_texCoord + vec2( 0.0, tex_offset.y ) ).r;
        alpha -= texture2D( CC_Texture1, v_texCoord + vec2( 0.0, -tex_offset.y) ).r;
    }

    if(alpha < 0.0) {
        alpha = -alpha;
    }

    if(withImage == 1.0) {
        if(result.a > 0.0) {
            gl_FragColor = result * result.a + vec4(glowColor.r * alpha, glowColor.g * alpha, glowColor.b * alpha, alpha) * (1.0 - result.a);
        } else {
            gl_FragColor = vec4(glowColor.r * alpha, glowColor.g * alpha, glowColor.b * alpha, alpha);
        }
    } else {
        gl_FragColor = vec4(glowColor.r * alpha, glowColor.g * alpha, glowColor.b * alpha, alpha);
    }
}