precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform vec3 CC_params;

void main()
{
    vec4 color;
    if (CC_TextureAlpha == 0.0) {
        color = texture2D(CC_Texture0, v_texCoord);
    } else {
        color = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        color.rgb *= color.a;// premultiply alpha channel
    }
    float factor1 = CC_params.x;
    float factor2 = CC_params.y;
    float alpha = CC_params.z;

    float texCoord = 1.0 - v_texCoord.y;
    if (texCoord < factor1) {
        color *= alpha * texCoord / factor1;
    } else if (texCoord < factor2) {
        color *= alpha;
    } else {
        color *= (1.0 - alpha) * (texCoord - factor2) / (1.0 - factor2) + alpha;
    }

    gl_FragColor = v_fragmentColor * color;
}
