
precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float CC_levelR;//最大为1，原色;0代表灰色
uniform float CC_levelG;//最大为1，原色;0代表灰色
uniform float CC_levelB;//最大为1，原色;0代表灰色

void main()
{
    vec4 texColor;
    if(CC_TextureAlpha == 0.0) {
        texColor = texture2D(CC_Texture0, v_texCoord);
    } else {
        texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        texColor.rgb *= texColor.a; // premultiply alpha channel
    }

    vec4 color1 = texColor * v_fragmentColor;
	float averageRGB = (color1.r + color1.g + color1.b) * (1. / 3.);
	float r = color1.r;
	float g = color1.g;
	float b = color1.b;
	float a = color1.a;

	float differR = r - averageRGB;
	float differG = g - averageRGB;
	float differB = b - averageRGB;
	
	r = averageRGB + differR * CC_levelR;
	g = averageRGB + differG * CC_levelG;
	b = averageRGB + differB * CC_levelB;

    gl_FragColor = vec4(r, g, b, color1.a);
}
