precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

void main() {
	vec4 texColor;
	if(CC_TextureAlpha == 0.0) {
		texColor = texture2D(CC_Texture0, v_texCoord);
	} else {
		texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
		texColor.rgb *= texColor.a; // premultiply alpha channel
	}

	vec3 mapped = vec3(1.0) - exp(-texColor.rgb * 1.0);
	vec3 result = pow(mapped, vec3(1.0 / 2.2));
	gl_FragColor = vec4(result, texColor.a);
}

