precision mediump float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

#define range 2.0
float getGlowAlpha(){

    vec4 srcColor = texture2D(CC_Texture0,v_texCoord);
    if(srcColor.a <= 0.02){
        return srcColor.a;
    }
    float per_step_x = 1.0;
    float per_step_y = 1.0;

    float totalAlpha = 0.0;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-2.0 * per_step_x, -2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-2.0 * per_step_x, -1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-2.0 * per_step_x, 0.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-2.0 * per_step_x, 1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-2.0 * per_step_x, 2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-1.0 * per_step_x, -2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-1.0 * per_step_x, -1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-1.0 * per_step_x, 0.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-1.0 * per_step_x, 1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(-1.0 * per_step_x, 2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(0.0 * per_step_x, -2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(0.0 * per_step_x, -1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(0.0 * per_step_x, 0.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(0.0 * per_step_x, 1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(0.0 * per_step_x, 2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(1.0 * per_step_x, -2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(1.0 * per_step_x, -1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(1.0 * per_step_x, 0.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(1.0 * per_step_x, 1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(1.0 * per_step_x, 2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(2.0 * per_step_x, -2.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(2.0 * per_step_x, -1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(2.0 * per_step_x, 0.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(2.0 * per_step_x, 1.0 * per_step_y)).a;
    totalAlpha += texture2D(CC_Texture0, v_texCoord + vec2(2.0 * per_step_x, 2.0 * per_step_y)).a;
    totalAlpha /= (range + range + 1.0) * (range + range + 1.0);
    return totalAlpha;
}
void main()
{
    vec4 color;
    if(CC_TextureAlpha == 0.0) {
       color = texture2D(CC_Texture0, v_texCoord);
    }else{
       color = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
       color.rgb *= color.a; // premultiply alpha channel
    }
    color = color * v_fragmentColor;
    float alpha = getGlowAlpha();
    if (alpha > 0.01) {
        alpha = 1.0 - alpha;
     }
    vec4 color_src = vec4(color.r * 0.8, color.g * 1.0, color.b * 0.8, color.a * 1.0) * alpha;

    gl_FragColor = color_src * color_src.a + color;
}
