precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform float bright;

void main() {
	vec4 texColor;
	if(CC_TextureAlpha == 0.0) {
		texColor = texture2D(CC_Texture0, v_texCoord);
	} else {
		texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
		texColor.rgb *= texColor.a; // premultiply alpha channel
	}

	float brightness = dot(texColor.rgb, vec3(0.2126, 0.7152, 0.0722));
	if(brightness > bright)
		gl_FragColor = vec4(texColor.rgb, 1.0);
	else
		gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
}

