#ifdef GL_ES
precision lowp float;
#endif
 
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform int i_angle; // 0~360
uniform int i_samp; // 10~20

float2 rotateUV(float2 uv, float degrees)
{
	const float PI = 3.14159265358979;
    const float Deg2Rad = (PI * 2.0) / 360.0;
    float rotationRadians = degrees * Deg2Rad;
    float s = sin(rotationRadians);
    float c = cos(rotationRadians);
    mat2 rotationMatrix = mat2(c, -s,
								s, c);
    uv -= 0.5;
    uv = mul(rotationMatrix, uv);
    uv += 0.5;
    return uv;
}

void main()
{
	const float PI = 3.14159265358979;
	const float Deg2Rad = (PI * 2.0) / 360.0;
    const float Rad2Deg = 180.0 / PI;
    vec2 v = v_texCoord;
	
	vec4 fragColor;
	float illuminationDecay = 1.0;
	illuminationDecay *= 1.0 / i_samp;
	for (float i = 0; i < i_samp; ++i)
	{
		v = rotateUV(v, 1);
		vec4 texel = texture2D(CC_Texture0, v);
		texel *= illuminationDecay;
		fragColor += texel;
	}

    gl_FragColor = fragColor;
}