#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform vec2  CC_onePixelSize;
uniform float CC_coefficient;
uniform vec2 CC_center;
vec4 calcColor4(){
	vec2  onePixelSize = vec2(0.01,0.01);	
	float coefficient = 4.0;
	vec2  center = CC_center;
	vec2 curPos = center-v_texCoord;
	float dis = length(curPos);
	//float coefficientDis1 = coefficient*dis;
	float sinF = curPos.y/dis;
	float cosF = curPos.x/dis;
	const float coefficientDis1 = 4.0;
	
	if(coefficientDis1 > 0.0) {
		vec4 sum = vec4(0.0);
		vec2 offset;
		float weight;
		float squareX;
		float sumWeight;
		                                                           
		for(float dx = 0.0; dx <= coefficientDis1; dx += 1.0) {
			weight = (coefficientDis1 - dx)*(coefficientDis1 - dx);
			
			offset.x = -dx * cosF * onePixelSize.x;
			offset.y = -dx * sinF *onePixelSize.x;
			sum += texture2D(CC_Texture0, v_texCoord + offset) * weight;
			sumWeight += weight;
			
			offset.x = dx * cosF * onePixelSize.x;
			offset.y = dx * sinF *onePixelSize.x;
			sum += texture2D(CC_Texture0, v_texCoord + offset) * weight;
			sumWeight += weight;

		}
		return sum/sumWeight * v_fragmentColor;
	}
	else {
		return texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
	}
}
vec4 calcColor7(){
	vec2  onePixelSize = vec2(0.01,0.01);	
	float coefficient = 7.0;
	vec2  center = CC_center;
	vec2 curPos = center-v_texCoord;
	float dis = length(curPos);
	//float coefficientDis1 = coefficient*dis;
	float sinF = curPos.y/dis;
	float cosF = curPos.x/dis;
	const float coefficientDis1 = 7.0;
	
	if(coefficientDis1 > 0.0) {
		vec4 sum = vec4(0.0);
		vec2 offset;
		float weight;
		float squareX;
		float sumWeight;
		                                                           
		for(float dx = 0.0; dx <= coefficientDis1; dx += 1.0) {
			weight = (coefficientDis1 - dx)*(coefficientDis1 - dx);
			
			offset.x = -dx * cosF * onePixelSize.x;
			offset.y = -dx * sinF *onePixelSize.x;
			sum += texture2D(CC_Texture0, v_texCoord + offset) * weight;
			sumWeight += weight;
			
			offset.x = dx * cosF * onePixelSize.x;
			offset.y = dx * sinF *onePixelSize.x;
			sum += texture2D(CC_Texture0, v_texCoord + offset) * weight;
			sumWeight += weight;

		}
		return sum/sumWeight * v_fragmentColor;
	}
	else {
		return texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
	}
}
vec4 calcColor10(){
	vec2  onePixelSize = vec2(0.01,0.01);	
	float coefficient = 10.0;
	vec2  center = CC_center;
	vec2 curPos = center-v_texCoord;
	float dis = length(curPos);
	//float coefficientDis1 = coefficient*dis;
	float sinF = curPos.y/dis;
	float cosF = curPos.x/dis;
	const float coefficientDis1 = 10.0;
	
	if(coefficientDis1 > 0.0) {
		vec4 sum = vec4(0.0);
		vec2 offset;
		float weight;
		float squareX;
		float sumWeight;
		                                                           
		for(float dx = 0.0; dx <= coefficientDis1; dx += 1.0) {
			weight = (coefficientDis1 - dx)*(coefficientDis1 - dx);
			
			offset.x = -dx * cosF * onePixelSize.x;
			offset.y = -dx * sinF *onePixelSize.x;
			sum += texture2D(CC_Texture0, v_texCoord + offset) * weight;
			sumWeight += weight;
			
			offset.x = dx * cosF * onePixelSize.x;
			offset.y = dx * sinF *onePixelSize.x;
			sum += texture2D(CC_Texture0, v_texCoord + offset) * weight;
			sumWeight += weight;

		}
		return sum/sumWeight * v_fragmentColor;
	}
	else {
		return texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
	}
}
void main() {	
	if(CC_coefficient >= 2.5)
		gl_FragColor = calcColor10();
	else if(CC_coefficient >= 1.0 && CC_coefficient < 2.5)
		gl_FragColor = calcColor7();
	else if(CC_coefficient > 0.0 && CC_coefficient < 1.0)
		gl_FragColor = calcColor4();
	else if(CC_coefficient <= 0.0)
		gl_FragColor = texture2D(CC_Texture0, v_texCoord) * v_fragmentColor;
}