
precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

void main()
{
    vec4 texColor;
    if(CC_TextureAlpha == 0.0) {
        texColor = texture2D(CC_Texture0, v_texCoord);
    } else {
        texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        texColor.rgb *= texColor.a; // premultiply alpha channel
    }
    vec4 color1 = texColor * v_fragmentColor;
	float brightness = (color1.r + color1.g + color1.b) * (1. / 1.8);
	float grayR = (1. ) * brightness;
	float grayG = (0.75) * brightness;
	float grayB = (0.4) * brightness;
    gl_FragColor = vec4(grayR, grayG, grayB, color1.a);
}
