precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_SlideCal;
uniform sampler2D u_Texture1;

uniform float n_startX;
uniform float n_endX;
uniform float n_startY;
uniform float n_endY;
uniform float u_alpha;

void main()
{
    vec2 offset_t = vec2(0.,0.);
    offset_t.x = sin(u_SlideCal); //(-1.0 left ~1.0 right)

    vec4 src_color = texture2D(CC_Texture0, v_texCoord).rgba;
    if(CC_TextureAlpha != 0.0) {
        src_color.a = texture2D(CC_Texture1, v_texCoord).r;
        src_color.rgb *= src_color.a; // premultiply alpha channel
    }

    float totalX = n_endX - n_startX;
    float tempStartX = v_texCoord.x - n_startX;
    float normalizedX = tempStartX / totalX;

    float totalY = n_endY - n_startY;
    float tempStartY = v_texCoord.y - n_startY;
    float normalizedY = tempStartY / totalY;

    vec2 normalizedCoord = vec2(normalizedX, normalizedY);

    vec2 s_color = normalizedCoord - offset_t;
    vec4 slide_color = texture2D(u_Texture1, s_color).rgba;

    float strength = 0.01;
    vec3 improve = strength * vec3(255, 255, 255);
    vec3 result = improve * vec3(src_color.r, src_color.g, src_color.b);

    gl_FragColor = vec4(result.rgb * slide_color.a * u_alpha + src_color.rgb, src_color.a);
}
