precision mediump float;

//#define Blend(base, blend, funcf) 		vec3(funcf(base.r, blend.r), funcf(base.g, blend.g), funcf(base.b, blend.b))
//#define BlendColorDodgef(base, blend) 	((blend == 1.0) ? blend : min(base / (1.0 - blend), 1.0))
//#define BlendColorDodge(base, blend) 	Blend(base, blend, BlendColorDodgef)

vec3 BlendColorDodge(vec3 base, vec3 blend)
{
	float r = blend.r == 1.0 ? blend.r : ( base.r / (1.0 - blend.r) < 1.0 ? (base.r / (1.0 - blend.r)) : 1.0);
	float g = blend.g == 1.0 ? blend.g : ( base.g / (1.0 - blend.g) < 1.0 ? (base.g / (1.0 - blend.g)) : 1.0);
	float b = blend.b == 1.0 ? blend.b : ( base.b / (1.0 - blend.b) < 1.0 ? (base.b / (1.0 - blend.b)) : 1.0);
	
	return vec3(r, g, b);
}


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_SlideCal;
uniform sampler2D u_Texture1;
uniform sampler2D u_Texture2;

uniform float u_alpha_delta;
uniform float u_scale;
uniform float u_switch;
uniform float u_ltrb;

void main()
{
	vec2 offset_t = vec2(0.,0.);
    offset_t.x = sin(u_SlideCal); //(-1.0 left ~1.0 right);
	
	if (u_ltrb >= 1.0)
		offset_t.y = offset_t.x;

	vec4 src_color = texture2D(CC_Texture0, v_texCoord).rgba;

    float totalX = 1.0;
    float tempStartX = v_texCoord.x/u_scale;
	float normalizedX = tempStartX / totalX;

    float totalY = 1.0;
    float tempStartY = v_texCoord.y/u_scale;
    float normalizedY = tempStartY / totalY;

    vec2 normalizedCoord = vec2(normalizedX, normalizedY);

    vec2 s_color = normalizedCoord - offset_t;
    vec4 slide_color = texture2D(u_Texture1, s_color).rgba;

	slide_color = vec4(slide_color.rgb*u_alpha_delta,u_alpha_delta);

    vec4 slide_color2 = texture2D(u_Texture2, v_texCoord).rgba;
	vec4 result;
	if(slide_color2.r >= 0.02){
		result = vec4(BlendColorDodge(src_color.rgb, slide_color.rgb),1.0);
		result.a = src_color.a;
		
		if (u_switch >= 1.0)
		{
			result.a += slide_color2.a*u_alpha_delta;
		}
	}else{
		result = src_color;
	}
	
    gl_FragColor = result; 
}
