
precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float u_brightRate;
uniform vec4 u_uvRange;

void main()
{
    vec4 texColor;
    if(CC_TextureAlpha == 0.0) {
        texColor = texture2D(CC_Texture0, v_texCoord);
    } else {
        texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        texColor.rgb *= texColor.a; // premultiply alpha channel
    }
    vec4 color1 = texColor * v_fragmentColor;

    float flipY = 1.0 - v_texCoord.y;
    if(v_texCoord.x < u_uvRange.x || v_texCoord.x > u_uvRange.y || flipY < u_uvRange.z || flipY > u_uvRange.w){
        gl_FragColor = color1;
    }else{
        float brightness = (color1.r + color1.g + color1.b) * (1. / 3.);
        float gray = u_brightRate * brightness;
        gl_FragColor = vec4(gray, gray, gray, color1.a);
    }
}
