
precision mediump float;


varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

uniform float step;
uniform float xSeg;
uniform float ySeg;

void main()
{
    vec4 texColor;
    vec2 texCoord = v_texCoord;
    if(xSeg > 1.0){
       texCoord.x = texCoord.x * xSeg + step;
    }
    if(ySeg > 1.0){
        texCoord.y = texCoord.y * ySeg + step;
    }
    texColor = texture2D(CC_Texture0, texCoord);
    if(v_texCoord.x > 0.7){
        texColor *= 0.0;
     }else if(v_texCoord.x >= 0.4 && v_texCoord.x <= 0.7){
        float opacity = 1.0 - ((v_texCoord.x - 0.4) / 0.3);
        texColor *=  opacity;
     }

    gl_FragColor = texColor* v_fragmentColor;
}
