precision mediump float;

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;

void main()
{
    vec4 texColor;
    if(CC_TextureAlpha == 0.0) {
        texColor = texture2D(CC_Texture0, v_texCoord);
    } else {
        texColor = vec4(texture2D(CC_Texture0, v_texCoord).rgb, texture2D(CC_Texture1, v_texCoord).r);
        texColor.rgb *= texColor.a; // premultiply alpha channel
    }

    vec3 coverColor;
	coverColor.r = (1.0 - texColor.r)*texColor.a;
	coverColor.g = (1.0 - texColor.g)*texColor.a;
	coverColor.b = (1.0 - texColor.b)*texColor.a;

    gl_FragColor = vec4(coverColor, texColor.a)*v_fragmentColor;
}
