attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

#ifdef GL_ES
varying lowp vec4 v_fragmentColor;
varying mediump vec2 v_texCoord;
#else
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
#endif

uniform mat4 viewMatrix;
uniform mat4 projectionMatrix;

void main()
{
    vec4 cameraSpaceOriginPos =  viewMatrix* CC_MVMatrix * vec4(0.0, 0.0, 0.0, 1.0);
    vec4 worldPos = vec4(a_position);

    worldPos.x -= CC_MVMatrix[3][0];
    worldPos.y -= CC_MVMatrix[3][1];
    worldPos.z -= CC_MVMatrix[3][2];

    vec4 cameraSpacePos = cameraSpaceOriginPos + vec4(worldPos.xyz, 1.0);

    gl_Position =  projectionMatrix * cameraSpacePos;
    v_fragmentColor = a_color;
    v_texCoord = a_texCoord;
}