package com.lilith.sdk.base.service;

import com.lilith.sdk.base.service.RemoteCallback;

import java.util.Map;
import java.util.List;
import android.os.Bundle;

/**
 * Created by duanedu on 2015/12/7.
 */
interface RemoteService {

     // common methods
     void quitSDKProcess(long delay);
     void setInitConfig(in Bundle config);
     void setLocale(String language, String country);
     void setOrientation(int orientation);
     void setAudit(boolean isAuidt);
     boolean getAudit();
     void setPayNotifyUrl(String notifyUrl);
     Bundle queryCurrentUser();
     Bundle queryCurrentUserInfo();
     boolean isCurrentUserNewReg();
     void clearAutoLogin();
     void adjustInitOnMainActCreate();
     void reportAll(String name, String token, in String[] parameter);
     void report(int type, String name, String token, in String[] parameter);
     void reportAllWithRevenue(String name, String token, String currency, double revenue, in String[] parameter);
     void reportWithRevenue(int type, String name, String token, String currency, double revenue, in String[] parameter);
     void reportStart(in Bundle bundle);
     void reportStop(in Bundle bundle);
     void reportResume(in Bundle bundle);
     void reportPause(in Bundle bundle);
     void reportOnCreate(in Bundle bundle);
     void reportOnNewIntent(in Bundle bundle);
     void reportRoleInfo(int eventType, in Bundle bundle);
     void logCrash(long threadId, String threadName, in Bundle bundle);
     void log(String tag, String message, in Map context);
     void setDefaultBackground(int id);
     List getUnHandledTransactions();
     void closeSDKUI();
     void consumePurchased(in String[] skus,in String[] exts);
     void generateQRCode(int width, int height);

     String registerRemoteCallback(RemoteCallback callback);

     long onKeyUp(int keyCode, in Bundle bundle);
     void addDiagnoseUrl(in Bundle bundle);
     boolean doDiagnose();

     // methods for domestic
     void sendPhoneVerifyCode(String number, RemoteCallback callback);
     void sendEmailVerify(String email, RemoteCallback callback);
     void associate(String id, String verifyCode, int assocType, RemoteCallback callback);
     void dissociate(String id, int assocType, RemoteCallback callback);

     // methods for abroad
     void querySkuItems(in String[] items, RemoteCallback callback);
     void pullGameRequests(String typeId, int pageIndex, RemoteCallback callback);
     void acquireThirdPartyUserInfo(in Bundle params, RemoteCallback callback);
     boolean isFacebookContainsPermission(String permission);
     void queryFacebookFriends(RemoteCallback callback);

     //special
     boolean isGoogleGamesConnected();
     void signOutGoogleGames(RemoteCallback callback);
     void releaseQuickLoginAccount(RemoteCallback callback);
     void payWebView(int payValues, String payname, String payDesc, String payContext, String currency, RemoteCallback callback);
     void startPayWithDB(int payValues, String payContext, RemoteCallback callback);

     void httpGeeTest(int type, in Bundle bundle, RemoteCallback callback);

     //new lilith report
     void reportInit();
     void reportGetVersion();
     void reportBeginLogin(int loginType, String loginId);
     void reportEndLogin(int loginType, String loginId, String openId, boolean isFirstLogin);
     void reportDownload(String fileName, int fileSize, String startTime, String endTime, boolean result);
     void reportPrePay();
     void reportPaySuccess();
     void reportPayFailed();
     void reportErrorLog(String errorContent);

     void refreshUnHandledPurchase();

     void internalTestAlertMsg(String button, String msg, String action);
     void openVipMode(boolean open);

     void getDeviceScore();

}
