//
// Created by 王银报 on 2018/5/29.
//

#include "jni.h"
#include "android/log.h"
#include "llh_uni_sdk_export.h"
#include "jin_assist.h"
#include "jni_utils.h"


#ifndef LOG_TAG
#define LOG_TAG "llh_uni_jni"
#endif

using namespace LLHUni;

#ifndef LOGD
#define LOGD(...) __android_log_print(ANDROID_LOG_DEBUG, LOG_TAG, __VA_ARGS__)
#endif


#ifndef JAVA_CLASS_METHOD
#define JAVA_CLASS_METHOD(RETTYPE ,METHOD) JNIEXPORT RETTYPE Java_com_lilith_uni_sdk_UniSDKJni_##METHOD
#endif



JNIEXPORT jint  JNI_OnLoad(JavaVM* vm, void* reserved)
{
    JniAssist::GetInstance().setJVM(vm);
    return  JniAssist::GetInstance().JniVerison;
}
JAVA_CLASS_METHOD(void, onInitCallback)(JNIEnv *env, jobject jobject1,
                                        jboolean success, jint err_code,
                                        jstring err_msg)
{

    LOGD("on init call back");

    LLHUniInitCallback  callback = JniAssist::GetInstance().GetLLHUniInitCallback();
    if (callback)
    {
        callback(static_cast<bool >(success),
                 static_cast<LLHUniErrCode> (err_code),
                 JniUtils::RetainCStr(JniUtils::JStrToCStr(env, err_msg)));
    }

}



JAVA_CLASS_METHOD(void, onLoginCallbck)(JNIEnv *env, jobject jobject,
                                        jboolean success, jstring user_str,
                                        jint err_code, jstring err_msg)
{
    LOGD("on login call back");

    LLHUniLoginCallback  callback = JniAssist::GetInstance().GetLLHUniLoginCallback();
    if (callback)
    {
        callback(static_cast<bool >(success),
                 JniAssist::GetInstance().JsonToLLHUniUser(JniUtils::JStrToCStr(env, user_str)),
                                                           static_cast<LLHUniErrCode>(err_code),
                 JniUtils::RetainCStr(JniUtils::JStrToCStr(env, err_msg)));

    }
}


JAVA_CLASS_METHOD(void, onPayCallback)(JNIEnv  *env, jobject _jobject,
                                       jboolean success, jstring payRequest,
                                       jint err_code, jstring err_msg)
{
    LOGD("on pay call back");

    LLHUniPayCallback  callback = JniAssist::GetInstance().GetLLHUniPayCallback();
    if (callback)
    {
        callback(static_cast<bool > (success),
                 JniAssist::GetInstance().JsonToLLHUniPayRequest(JniUtils::JStrToCStr(env ,payRequest)),
                 static_cast<LLHUniErrCode>(err_code),
                 JniUtils::RetainCStr(JniUtils::JStrToCStr(env, err_msg)));

    }

}



JAVA_CLASS_METHOD(void, onExitCallback)(JNIEnv *env, jobject jobject1,
                                        jboolean success)
{
    LOGD("on exit call back");

    LLHUniExitCallback callback = JniAssist::GetInstance().GetLLHUniExitCallback();
    if (callback)
    {
        callback(static_cast<bool> (success));
    }

}


JAVA_CLASS_METHOD(void, onPermissionRequestCallback)(JNIEnv *env, jobject jobject1, jboolean success)
{
    LOGD("on permission request  call back");

    LLHUniPermissionRequestCallback  callback = JniAssist::GetInstance().GetLLHUniPermissionRequestCallback();
    if (callback)
    {
        callback(static_cast<bool > (success));
    }


}