//
// Created by 王银报 on 2018/6/1.
//

#ifndef LILITHSDKPROJ_LLH_UNI_SDK_EXPORT_H
#define LILITHSDKPROJ_LLH_UNI_SDK_EXPORT_H

#ifdef __cplusplus
extern "C"
{
#endif

#include "stdint.h"
#include "math.h"

typedef enum
{
    KLLHUniErrCodeExitUserCanceled = -30,

    KLLHUniErrCodeInitFailedNeedContinueLogin = -31,


    KLLHUniErrCodeErrSuccess = 0,

} LLHUniErrCode;

typedef struct
{
    const char *id;
    const char *token;
    const char *user_name;
    const char *avatar_url;
} LLHUniUser;


typedef struct
{
    const char *order_id;
    uint32_t price;
    double_t exchange_rate;
    const char *unit;
    const char *item_id;
    int64_t item_id_serial;
    const char *item_name;
    const char *item_desc;
    const char *coin_icon_path;
    const char *extension;
    const char *internal_item_id;
} LLHUniPayRequest;


typedef enum
{
    Event_ENTER_SERVER =1, // 进入服务器
    Event_ROLE_CREATE =2, // 创角
    Event_LEVEL_UP =3, // 升级
    Event_EXIT_SERVE=4, // 退出服务器

} LLHUniReportGameEventType;

typedef struct
{
    const char *role_id;
    const char *role_name;
    uint32_t level;
    uint32_t vip_level;
    long server_id;
    const char *server_name;
    int64_t guild_id;
    const char *guild;
    uint32_t balance;
    const char *balance_unit;
    long role_create_time;
    long role_level_change_time;
} LLHUniGameInfo;


typedef void (*LLHUniLoginCallback) (bool success, LLHUniUser *user, LLHUniErrCode err_code, const char *error_msg);
typedef void (*LLHUniPayCallback) (bool success, LLHUniPayRequest *pay_request, LLHUniErrCode err_code, const char *error_msg);
typedef void (*LLHUniExitCallback)(bool success);
typedef void (*LLHUniInitCallback) (bool success, LLHUniErrCode err_code, const char *err_msg);
typedef void (*LLHUniPermissionRequestCallback) (bool success);




void LLHUniRegisterInitCallback(LLHUniInitCallback callback);
void LLHUniRegisterLoginCallbck(LLHUniLoginCallback callback);
void LLHUniRegisterPayCallback(LLHUniPayCallback callback);
void LLHUniRegisterExitCallback(LLHUniExitCallback callback);
void LLHUniRegisterPermissionRequestCallback(LLHUniPermissionRequestCallback callback);



const char *LLHUniGetType();
const char *LLHUniGetThirdPartyVerison();
const char *LLHUniGetChannelID();

void LLHIndeCheckPermissions();

bool LLHUniIsLoginValid();
bool LLHUniLogin();

LLHUniUser *LLHUniGetCurrentUser();
LLHUniUser *LLHUniGetLastUser();


bool LLHUniIsPayValid();
void LLHUniPay(LLHUniPayRequest *pay_request);
void LLHUniPayWithApplyOrderId(LLHUniPayRequest *pay_request);


void LLHUniShareImageToThird(const char* path);

void LLHUniReportGameInfo(uint32_t event, LLHUniGameInfo *gameInfo);


bool LLHUniIsSwichAccountValid();
void LLHUniSwichAccount();

bool LLHUniIsQuitLoginValid();
void LLHUniQuitLogin();

bool LLHUniIsExitValid();
void LLHUniExit();


void LLHUniStartAuthenticationInfo();







};


#endif //LILITHSDKPROJ_LLH_UNI_SDK_EXPORT_H
